## samba 4.5.16+dfsg

=== ctdb/wscript ===
#!/usr/bin/env python

APPNAME = 'ctdb'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs, Utils
import samba_utils, samba_version

env = samba_utils.LOAD_ENVIRONMENT()
if os.path.isfile('./VERSION'):
    vdir = '.'
elif os.path.isfile('../VERSION'):
    vdir = '..'
else:
    Logs.error("VERSION file not found")

version = samba_version.samba_version_file('%s/VERSION' % vdir, vdir, env)
VERSION = version.STRING.replace('-', '.')

default_prefix = Options.default_prefix = '/usr/local'

samba_dist.DIST_DIRS('''ctdb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tevent:lib/tevent lib/tdb:lib/tdb
                        lib/socket_wrapper:lib/socket_wrapper
                        third_party/popt:third_party/popt
                        lib/util:lib/util lib/tdb_wrap:lib/tdb_wrap
                        lib/ccan:lib/ccan libcli/util:libcli/util
                        lib/async_req:lib/async_req
                        buildtools:buildtools third_party/waf:third_party/waf''')

manpages = [
    'ctdb.1',
    'ctdb.7',
    'ctdb_diagnostics.1',
    'ctdbd.1',
    'ctdbd.conf.5',
    'ctdbd_wrapper.1',
    'ctdb-statistics.7',
    'ctdb-tunables.7',
    'ltdbtool.1',
    'onnode.1',
    'ping_pong.1'
]


def set_options(opt):
    opt.PRIVATE_EXTENSION_DEFAULT('ctdb')

    opt.RECURSE('lib/replace')

    opt.RECURSE('lib/util')

    opt.RECURSE('lib/talloc')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/tdb')

    opt.add_option('--enable-infiniband',
                   help=("Turn on infiniband support (default=no)"),
                   action="store_true", dest='ctdb_infiniband', default=False)
    opt.add_option('--enable-pmda',
                   help=("Turn on PCP pmda support (default=no)"),
                   action="store_true", dest='ctdb_pmda', default=False)

    opt.add_option('--with-logdir',
                   help=("Path to log directory"),
                   action="store", dest='ctdb_logdir', default=None)
    opt.add_option('--with-socketpath',
                   help=("path to CTDB daemon socket"),
                   action="store", dest='ctdb_sockpath', default=None)


def configure(conf):

    # No need to build python bindings for talloc/tevent/tdb
    if conf.IN_LAUNCH_DIR():
        conf.env.standalone_ctdb = True
        Options.options.disable_python = True

    conf.RECURSE('lib/replace')

    if conf.env.standalone_ctdb:
        conf.SAMBA_CHECK_PERL(mandatory=True)

        conf.SAMBA_CHECK_PYTHON(mandatory=True, version=(2,5,0))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
    else:
        if not conf.CHECK_POPT():
            raise Utils.WafError('popt development packages have not been found\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

    conf.RECURSE('lib/util')

    conf.RECURSE('lib/talloc')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/tdb')
    if conf.env.standalone_ctdb or conf.CONFIG_GET('ENABLE_SELFTEST'):
        conf.RECURSE('lib/socket_wrapper')
        conf.env.SOCKET_WRAPPER_SO_PATH = conf.CONFIG_GET('LIBSOCKET_WRAPPER_SO_PATH')

    conf.CHECK_HEADERS('sched.h')
    conf.CHECK_HEADERS('procinfo.h')
    if sys.platform.startswith('aix') and not conf.CHECK_FUNCS('thread_setsched'):
        Logs.error('Need thread_setsched() on AIX')
        sys.exit(1)
    elif not conf.CHECK_FUNCS('sched_setscheduler'):
        Logs.error('Need sched_setscheduler()')
        sys.exit(1)
    conf.CHECK_FUNCS('mlockall')

    if not conf.CHECK_VARIABLE('ETIME', headers='errno.h'):
        conf.DEFINE('ETIME', 'ETIMEDOUT')

    if sys.platform.startswith('linux'):
        conf.SET_TARGET_TYPE('pcap', 'EMPTY')
    else:
        if not conf.CHECK_HEADERS('pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)
        if not conf.CHECK_FUNCS_IN('pcap_open_live', 'pcap', headers='pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)

    if not conf.CHECK_FUNCS_IN('backtrace backtrace_symbols', 'execinfo',
                               checklibc=True, headers='execinfo.h'):
        Logs.error('backtrace support not available')

    have_pmda = False
    if Options.options.ctdb_pmda:
        pmda_support = True

        if not conf.CHECK_HEADERS('pcp/pmapi.h pcp/impl.h pcp/pmda.h',
                                  together=True):
            pmda_support = False
        if not conf.CHECK_FUNCS_IN('pmProgname', 'pcp'):
            pmda_support = False
        if not conf.CHECK_FUNCS_IN('pmdaDaemon', 'pcp_pmda'):
            pmda_support = False
        if pmda_support:
            have_pmda = True
        else:
            Logs.error("PMDA support not available")
            sys.exit(1)
    if have_pmda:
        Logs.info('Building with PMDA support')
        conf.define('HAVE_PMDA', 1)
        conf.env.CTDB_PMDADIR = os.path.join(conf.env.LOCALSTATEDIR,
                                             'lib/pcp/pmdas/ctdb')

    have_infiniband = False
    if Options.options.ctdb_infiniband:
        ib_support = True

        if not conf.CHECK_HEADERS('infiniband/verbs.h rdma/rdma_cma.h'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('ibv_create_qp', 'ibverbs'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('rdma_connect', 'rdmacm'):
            ib_support = False
        if ib_support:
            have_infiniband = True
        else:
            Logs.error("Infiniband support not available")
            sys.exit(1)
    if have_infiniband:
        Logs.info('Building with Infiniband support')
        conf.define('HAVE_INFINIBAND', 1)
        conf.define('USE_INFINIBAND', 1)

    conf.env.CTDB_BINDIR = os.path.join(conf.env.EXEC_PREFIX, 'bin')
    conf.env.CTDB_ETCDIR = os.path.join(conf.env.SYSCONFDIR, 'ctdb')
    conf.env.CTDB_VARDIR = os.path.join(conf.env.LOCALSTATEDIR, 'lib/ctdb')
    conf.env.CTDB_RUNDIR = os.path.join(conf.env.LOCALSTATEDIR, 'run/ctdb')
    conf.env.CTDB_HELPER_BINDIR = os.path.join(conf.env.LIBEXECDIR, 'ctdb')

    if Options.options.ctdb_logdir:
        conf.env.CTDB_LOGDIR = Options.options.ctdb_logdir
    else:
        conf.env.CTDB_LOGDIR = os.path.join(conf.env.LOCALSTATEDIR, 'log')

    if Options.options.ctdb_sockpath:
        conf.env.CTDB_SOCKPATH = Options.options.ctdb_sockpath
    else:
        conf.env.CTDB_SOCKPATH = os.path.join(conf.env.CTDB_RUNDIR,
                                              'ctdbd.socket')
    conf.define('CTDB_SOCKET', conf.env.CTDB_SOCKPATH)

    conf.ADD_CFLAGS('''-DCTDB_HELPER_BINDIR=\"%s\"
                       -DLOGDIR=\"%s\"
                       -DCTDB_ETCDIR=\"%s\"
                       -DCTDB_VARDIR=\"%s\"
                       -DCTDB_RUNDIR=\"%s\"''' % (
                    conf.env.CTDB_HELPER_BINDIR,
                    conf.env.CTDB_LOGDIR,
                    conf.env.CTDB_ETCDIR,
                    conf.env.CTDB_VARDIR,
                    conf.env.CTDB_RUNDIR))

    conf.env.CTDB_TEST_DATADIR = os.path.join(conf.env.EXEC_PREFIX,
                                              'share/ctdb/tests')
    conf.env.CTDB_TEST_LIBEXECDIR = os.path.join(conf.env.LIBEXECDIR, 'ctdb/tests')

    # Allow unified compilation and separate compilation of utilities
    # to find includes
    if not conf.env.standalone_ctdb:
        conf.ADD_EXTRA_INCLUDES('#include/public #ctdb/include #ctdb')
    else:
        if srcdir == '.':
            # Building from tarball
            conf.ADD_EXTRA_INCLUDES('#include')
        else:
            # Building standalone CTDB from within Samba tree
            conf.ADD_EXTRA_INCLUDES('#ctdb/include')
            conf.ADD_EXTRA_INCLUDES('#ctdb')
        conf.ADD_EXTRA_INCLUDES('#lib #lib/replace')

        conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)
        conf.DEFINE('SAMBA_UTIL_CORE_ONLY', 1, add_to_cflags=True)
        conf.SAMBA_CONFIG_H()

    if 'XSLTPROC_MANPAGES' in conf.env and conf.env['XSLTPROC_MANPAGES']:
        conf.env.ctdb_generate_manpages = True
    else:
        conf.env.ctdb_generate_manpages = False

        Logs.info("xsltproc unavailable, checking for pre-built manpages")
        conf.env.ctdb_prebuilt_manpages = []
        for m in manpages:
            if os.path.exists(os.path.join("doc", m)):
                Logs.info("  %s: yes" % (m))
                conf.env.ctdb_prebuilt_manpages.append(m)
            else:
                Logs.info("  %s: no" % (m))

def build(bld):
    if bld.env.standalone_ctdb:
        # enable building of public headers in the build tree
        bld.env.build_public_headers = 'include/public'

    version_h = samba_utils.os_path_relpath(os.path.join(Options.launch_dir,
                                                         "version.h"),
                                            bld.curdir)

    if bld.env.standalone_ctdb:
        ctdb_mkversion = '../packaging/mkversion.sh'
        t = bld.SAMBA_GENERATOR('ctdb-version-header',
                                target='include/ctdb_version.h',
                                rule='%s ${TGT} %s' % (ctdb_mkversion, VERSION),
                                dep_vars=['VERSION'])
        t.env.VERSION = VERSION

        t = bld.SAMBA_GENERATOR('ctdb-samba-version-header',
                                target=version_h,
                                rule='printf "#include \\"ctdb_version.h\\" \\n#define SAMBA_VERSION_STRING CTDB_VERSION_STRING\\n" > ${TGT}',
                                dep_vars=['VERSION'])
        t.env.VERSION = VERSION
    else:
        t = bld.SAMBA_GENERATOR('ctdb-samba-version-header',
                                target='include/ctdb_version.h',
                                rule='printf "#include \\"%s\\" \\n#define CTDB_VERSION_STRING SAMBA_VERSION_STRING\\n" > ${TGT}' % version_h,
                                dep_vars=['VERSION'])
        t.env.VERSION = VERSION

    bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'

    bld.RECURSE('lib/replace')
    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')

    bld.RECURSE('lib/tdb_wrap')
    bld.RECURSE('lib/util')
    bld.RECURSE('lib/async_req')

    bld.RECURSE('lib/talloc')
    bld.RECURSE('lib/tevent')
    bld.RECURSE('lib/tdb')
    if bld.env.standalone_ctdb or bld.CONFIG_GET('SOCKET_WRAPPER'):
        bld.RECURSE('lib/socket_wrapper')

    if bld.env.standalone_ctdb:
        # If a combined build is implemented, CTDB will want to
        # build against samba-util rather than samba-util-core.
        # Similarly, other Samba subsystems expect samba-util.  So,
        # for a standalone build, just define a fake samba-util
        # subsystem that pulls in samba-util-core.
        bld.SAMBA_SUBSYSTEM('samba-util',
                            source='',
                            deps='samba-util-core')

    bld.SAMBA_SUBSYSTEM('ctdb-tcp',
                        source=bld.SUBDIR('tcp',
                                          'tcp_connect.c tcp_init.c tcp_io.c'),
                        includes='include',
                        deps='replace tdb talloc tevent')

    ib_deps = ''
    if bld.env.HAVE_INFINIBAND:
        bld.SAMBA_SUBSYSTEM('ctdb-ib',
                            source=bld.SUBDIR('ib',
                                              '''ibwrapper.c ibw_ctdb.c
                                                 ibw_ctdb_init.c'''),
                            includes='include',
                            deps='replace talloc tevent tdb')
        ib_deps = ' ctdb-ib rdmacm ibverbs'

    if sys.platform.startswith('linux'):
        CTDB_SYSTEM_SRC = bld.SUBDIR('common', 'system_linux.c')

=== source3/wscript ===
#!/usr/bin/env python

srcdir=".."

import sys, os
from optparse import SUPPRESS_HELP
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
sys.path.insert(0, "source3")
import wafsamba, Options, Logs, Utils, Scripting
import build.charset
import samba_utils, samba_version
import samba3

default_prefix = Options.default_prefix = '/usr/local/samba'

def set_options(opt):

    opt.add_option('--with-static-modules',
                   help=("Comma-separated list of names of modules to statically link in. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required static only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a static build. "+
                         "Can be 'ALL' to build all default shared modules static. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='static_modules', default=None)
    opt.add_option('--with-shared-modules',
                   help=("Comma-separated list of names of modules to build shared. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required shared only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a shared build. "+
                         "Can be 'ALL' to build all default static modules shared. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='shared_modules', default=None)

    opt.SAMBA3_ADD_OPTION('winbind')
    opt.SAMBA3_ADD_OPTION('ads')
    opt.SAMBA3_ADD_OPTION('ldap')
    opt.SAMBA3_ADD_OPTION('cups', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iprint', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('pam')
    opt.SAMBA3_ADD_OPTION('quotas')
    opt.SAMBA3_ADD_OPTION('sendfile-support')
    opt.SAMBA3_ADD_OPTION('utmp')
    opt.SAMBA3_ADD_OPTION('pthreadpool', with_name="enable", without_name="disable", default=True)
    opt.SAMBA3_ADD_OPTION('avahi', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iconv')
    opt.SAMBA3_ADD_OPTION('acl-support')
    opt.SAMBA3_ADD_OPTION('dnsupdate')
    opt.SAMBA3_ADD_OPTION('syslog')
    opt.SAMBA3_ADD_OPTION('automount')
    opt.SAMBA3_ADD_OPTION('dmapi', default=None) # None means autodetection
    opt.SAMBA3_ADD_OPTION('fam', default=None) # None means autodetection
    opt.SAMBA3_ADD_OPTION('profiling-data', default=False)
    opt.SAMBA3_ADD_OPTION('libarchive', default=None)

    opt.SAMBA3_ADD_OPTION('cluster-support', default=False)

    opt.SAMBA3_ADD_OPTION('regedit', default=None)

    opt.SAMBA3_ADD_OPTION('fake-kaserver',
                          help=("Include AFS fake-kaserver support"), default=False)

    opt.add_option('--with-libcephfs',
                   help=("Directory under which libcephfs is installed"),
                   action="store", dest='libcephfs_dir', default=None)

    opt.SAMBA3_ADD_OPTION('glusterfs', with_name="enable", without_name="disable", default=True)
    opt.SAMBA3_ADD_OPTION('cephfs', with_name="enable", without_name="disable", default=True)

    opt.add_option('--enable-vxfs',
                  help=("enable support for VxFS (default=no)"),
                  action="store_true", dest='enable_vxfs', default=False)

    opt.SAMBA3_ADD_OPTION('spotlight', with_name="enable", without_name="disable", default=False)

def configure(conf):
    from samba_utils import TO_LIST

    default_static_modules = []
    default_shared_modules = []
    required_static_modules = []
    forced_static_modules = []
    forced_shared_modules = []

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.developer = True

    if sys.platform != 'openbsd5':
        conf.ADD_LDFLAGS("-Wl,--export-dynamic", testflags=True)

    # We crash without vfs_default
    required_static_modules.extend(TO_LIST('vfs_default'))

    conf.CHECK_HEADERS('execinfo.h libexc.h libunwind.h netdb.h')
    conf.CHECK_HEADERS('linux/falloc.h linux/ioctl.h')

    conf.CHECK_FUNCS('getcwd fchown chmod fchmod mknod')
    conf.CHECK_FUNCS('strtol strchr strupr chflags')
    conf.CHECK_FUNCS('getrlimit fsync fdatasync setpgid')
    conf.CHECK_FUNCS('setsid glob strpbrk crypt16 getauthuid')
    conf.CHECK_FUNCS('innetgr')
    conf.CHECK_FUNCS('initgroups select poll rdchk getgrnam getgrent pathconf')
    conf.CHECK_FUNCS('setpriv setgidx setuidx setgroups syscall sysconf')
    conf.CHECK_FUNCS('atexit grantpt posix_openpt fallocate posix_fallocate')
    conf.CHECK_FUNCS('fseeko setluid')
    conf.CHECK_FUNCS('getpwnam', headers='sys/types.h pwd.h')
    conf.CHECK_FUNCS('fdopendir')
    conf.CHECK_FUNCS('fstatat')
    conf.CHECK_FUNCS('getpwent_r setenv clearenv strcasecmp fcvt fcvtl')
    conf.CHECK_FUNCS('syslog vsyslog timegm setlocale')
    conf.CHECK_FUNCS_IN('nanosleep', 'rt')
    conf.CHECK_FUNCS('lutimes futimes utimensat futimens')
    conf.CHECK_FUNCS('mlock munlock mlockall munlockall')
    conf.CHECK_FUNCS('memalign posix_memalign hstrerror')
    conf.CHECK_FUNCS('shmget')
    conf.CHECK_FUNCS_IN('shm_open', 'rt', checklibc=True)
    #FIXME: for some reason this one still fails
    conf.CHECK_FUNCS_IN('yp_get_default_domain', 'nsl')
    conf.CHECK_FUNCS_IN('dn_expand _dn_expand __dn_expand', 'resolv')
    conf.CHECK_FUNCS_IN('dn_expand', 'inet')
    conf.CHECK_DECLS('fdatasync', reverse=True)
    conf.CHECK_DECLS('readahead', reverse=True, headers='fcntl.h')

    if conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
long ret = splice(0,0,1,0,400,SPLICE_F_MOVE);
''',
        'HAVE_LINUX_SPLICE',
        headers='fcntl.h'):
        conf.CHECK_DECLS('splice', reverse=True, headers='fcntl.h')

    # Check for inotify support (Skip if we are SunOS)
    #NOTE: illumos provides sys/inotify.h but is not an exact match for linux
    host_os = sys.platform
    if host_os.rfind('sunos') == -1:
        conf.CHECK_HEADERS('sys/inotify.h')
        if "HAVE_SYS_INOTIFY_H" in conf.env:
           conf.DEFINE('HAVE_INOTIFY', 1)

    # Check for kernel change notify support
    conf.CHECK_CODE('''
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_CHANGE_NOTIFY', addmain=False, execute=True,
        headers='fcntl.h signal.h',
        msg="Checking for kernel change notify support")

    # Check for Linux kernel oplocks
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#ifndef F_GETLEASE
#define F_GETLEASE 1025
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_GETLEASE, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_OPLOCKS_LINUX', addmain=False, execute=True,
        msg="Checking for Linux kernel oplocks")

    # Check for IRIX kernel oplock types
    conf.CHECK_CODE('oplock_stat_t t; t.os_state = OP_REVOKE; t.os_dev = 1; t.os_ino = 1;',
                    'HAVE_KERNEL_OPLOCKS_IRIX', headers='fcntl.h',
                    msg="Checking for IRIX kernel oplock types")

    # Check for kernel share modes
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/file.h>
#ifndef LOCK_MAND
#define LOCK_MAND        32
#define LOCK_READ        64
#endif
main() {
        exit(flock(open("/dev/null", O_RDWR), LOCK_MAND|LOCK_READ) != 0);
}''', 'HAVE_KERNEL_SHARE_MODES', addmain=False, execute=True,
        msg="Checking for kernel share modes")

    # check for fam libs
    samba_fam_libs=None
    check_for_fam=False
    if Options.options.with_fam is None:
        check_for_fam=True
    elif Options.options.with_fam == True:
        check_for_fam=True

    if check_for_fam and conf.CHECK_HEADERS('fam.h'):
        if conf.CHECK_FUNCS_IN('FAMOpen2', 'fam'):
            samba_fam_libs='fam'
        elif conf.CHECK_FUNCS_IN('FAMOpen2', 'fam C'):
            samba_fam_libs='fam C'
        conf.CHECK_TYPE('enum FAMCodes', headers='fam.h',
            define='HAVE_FAM_H_FAMCODES_TYPEDEF',
            msg='Checking whether enum FAMCodes is available')
        conf.CHECK_FUNCS_IN('FAMNoExists', 'fam')

    if samba_fam_libs is not None:
        conf.DEFINE('SAMBA_FAM_LIBS', samba_fam_libs)
        conf.DEFINE('HAVE_FAM', 1)
    else:
        if Options.options.with_fam == True:
            conf.fatal('FAM support requested, but no suitable FAM library found')
        elif check_for_fam:
            Logs.warn('no suitable FAM library found')

    # check for libarchive (tar command in smbclient)
    # None means autodetect, True/False means enable/disable
    conf.SET_TARGET_TYPE('archive', 'EMPTY')
    if Options.options.with_libarchive is not False:
        libarchive_mandatory = Options.options.with_libarchive == True
        Logs.info("Checking for libarchive existence")
        if conf.CHECK_HEADERS('archive.h') and conf.CHECK_LIB('archive', shlib=True):
            conf.CHECK_FUNCS_IN('archive_read_support_filter_all archive_read_free', 'archive')
        elif libarchive_mandatory:
            conf.fatal('libarchive support requested, but not found')

    # check for DMAPI libs
    if Options.options.with_dmapi == False:
        have_dmapi = False
    else:
        have_dmapi = True
        Logs.info("Checking for DMAPI library existence")
        samba_dmapi_lib = ''
        if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dm'):
            samba_dmapi_lib = 'dm'
        else:
            if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'jfsdm'):
                samba_dmapi_lib = 'jfsdm'
            else:
                if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dmapi'):
                    samba_dmapi_lib = 'dmapi'
                else:
                    if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'xdsm'):
                        samba_dmapi_lib = 'xdsm'
        # only bother to test headers and compilation when a candidate
        # library has been found
        if samba_dmapi_lib == '':
            have_dmapi = False
            broken_dmapi = "no suitable DMAPI library found"

        if have_dmapi:
            conf.CHECK_HEADERS('sys/dmi.h xfs/dmapi.h sys/jfsdmapi.h sys/dmapi.h dmapi.h')
            conf.CHECK_CODE('''
#include <time.h>      /* needed by Tru64 */
#include <sys/types.h> /* needed by AIX */
#ifdef HAVE_XFS_DMAPI_H
#include <xfs/dmapi.h>
#elif defined(HAVE_SYS_DMI_H)
#include <sys/dmi.h>
#elif defined(HAVE_SYS_JFSDMAPI_H)
#include <sys/jfsdmapi.h>
#elif defined(HAVE_SYS_DMAPI_H)
#include <sys/dmapi.h>
#elif defined(HAVE_DMAPI_H)
#include <dmapi.h>
#endif

/* This link test is designed to fail on IRI 6.4, but should
 * succeed on Linux, IRIX 6.5 and AIX.
 */
int main(int argc, char **argv)
{
	char * version;
	dm_eventset_t events;
	/* This doesn't take an argument on IRIX 6.4. */
	dm_init_service(&version);
	/* IRIX 6.4 expects events to be a pointer. */
	DMEV_ISSET(DM_EVENT_READ, events);

	return 0;
}
''',
            'USEABLE_DMAPI_LIBRARY',
            addmain=False,
            execute=False,
            lib=samba_dmapi_lib,
            msg='Checking whether DMAPI lib '+samba_dmapi_lib+' can be used')
            if not conf.CONFIG_SET('USEABLE_DMAPI_LIBRARY'):
                have_dmapi = False
                broken_dmapi = "no usable DMAPI library found"

    if have_dmapi:
        Logs.info("Building with DMAPI support.")
        conf.env['dmapi_lib'] = samba_dmapi_lib
        conf.DEFINE('USE_DMAPI', 1)
    else:
        if Options.options.with_dmapi == False:

=== lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
VERSION = '1.1.27'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Utils

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent
                        third_party/popt:third_party/popt
                        buildtools:buildtools third_party/waf:third_party/waf''')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.tool_options('python') # options for disabling pyc or pyo compilation

def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
    else:
        if not conf.CHECK_POPT():
            raise Utils.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

    conf.RECURSE('lib/replace')
    conf.find_program('python', var='PYTHON')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.check_tool('python')
    conf.check_python_version((2,4,2))
    conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        #
        # ldb >= 1.2.0 (as well as 1.1.30 and 1.1.31) are
        # incompatible with Samba < 4.7
        #
        # See https://bugzilla.samba.org/show_bug.cgi?id=12859
        #
        maxversion = "1.1.99"
        version_blacklist = ["1.1.30", "1.1.31"]

        if conf.CHECK_BUNDLED_SYSTEM_PKG('pyldb-util',
                                     minversion=VERSION,
                                     maxversion=maxversion,
                                     version_blacklist=version_blacklist,
                                     onlyif='talloc tdb tevent',
                                     implied_deps='replace talloc tdb tevent ldb'):
            conf.define('USING_SYSTEM_PYLDB_UTIL', 1)
            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                         minversion=VERSION,
                                         maxversion=maxversion,
                                         version_blacklist=version_blacklist,
                                         onlyif='talloc tdb tevent pyldb-util',
                                         implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if not sys.platform.startswith("openbsd"):
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')

    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')

    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        private_library = False
    else:
        private_library = True

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    if not 'PACKAGE_VERSION' in bld.env:
        bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'

    if not bld.env.disable_python:
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            for env in bld.gen_python_environments(['PKGCONFIGDIR']):
                name = bld.pyembed_libname('pyldb-util')
                bld.SAMBA_LIBRARY(name,
                                  deps='ldb',
                                  source='pyldb_util.c',
                                  public_headers=('' if private_library else 'pyldb.h'),
                                  public_headers_install=not private_library,
                                  vnum=VERSION,
                                  private_library=private_library,
                                  pc_files='pyldb-util.pc',
                                  pyembed=True,
                                  abi_directory='ABI',
                                  abi_match='pyldb_*')

                if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
                    bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                                     deps='ldb ' + name,
                                     realname='ldb.so',
                                     cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

            for env in bld.gen_python_environments(['PKGCONFIGDIR']):
                bld.SAMBA_SCRIPT('_ldb_text.py',
                                 pattern='_ldb_text.py',
                                 installdir='python')

                bld.INSTALL_FILES('${PYTHONARCHDIR}', '_ldb_text.py')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if bld.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        ldb_headers = ('include/ldb.h include/ldb_errors.h '
                       'include/ldb_module.h include/ldb_handlers.h')

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN replace',
                          includes='include',
                          public_headers=('' if private_library else ldb_headers),
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
                          manpages='man/ldb.3',
                          abi_directory='ABI',
                          abi_match = abi_match)

        # generate a include/ldb_version.h
        t = bld.SAMBA_GENERATOR('ldb_version.h',
                                rule='echo "#define LDB_VERSION \\"${LDB_VERSION}\\"" > ${TGT}',
                                dep_vars=['LDB_VERSION'],
                                target='include/ldb_version.h',
                                public_headers='include/ldb_version.h',
                                public_headers_install=not private_library)
        t.env.LDB_VERSION = VERSION


        bld.SAMBA_MODULE('ldb_paged_results',
                         'modules/paged_results.c',
                         init_function='ldb_paged_results_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_asq',
                         'modules/asq.c',
                         init_function='ldb_asq_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_server_sort',
                         'modules/sort.c',
                         init_function='ldb_server_sort_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_paged_searches',
                         'modules/paged_searches.c',
                         init_function='ldb_paged_searches_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_rdn_name',
                         'modules/rdn_name.c',
                         init_function='ldb_rdn_name_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sample',
                         'tests/sample_module.c',
                         init_function='ldb_sample_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_skel',
                         'modules/skel.c',
                         init_function='ldb_skel_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_sqlite3',
                         'sqlite3/ldb_sqlite3.c',
                         init_function='ldb_sqlite3_init',
                         internal_module=False,
                         module_init_name='ldb_init_module',
                         enabled=False,
                         deps='ldb',
                         subsystem='ldb')

        bld.SAMBA_MODULE('ldb_tdb',
                         bld.SUBDIR('ldb_tdb',
                                    '''ldb_tdb.c ldb_search.c ldb_index.c
                                    ldb_cache.c ldb_tdb_wrap.c'''),
                         init_function='ldb_tdb_init',
                         module_init_name='ldb_init_module',
                         internal_module=False,
                         deps='tdb ldb',
                         subsystem='ldb')

        # have a separate subsystem for common/ldb.c, so it can rebuild
        # for install with a different -DLDB_MODULESDIR=
        bld.SAMBA_SUBSYSTEM('LIBLDB_MAIN',
                            'common/ldb.c',
                            deps='tevent tdb',
                            includes='include',
                            cflags=['-DLDB_MODULESDIR=\"%s\"' % modules_dir])

        LDB_TOOLS='ldbadd ldbsearch ldbdel ldbmodify ldbedit ldbrename'
        for t in LDB_TOOLS.split():
            bld.SAMBA_BINARY(t, 'tools/%s.c' % t, deps='ldb-cmdline ldb',
                             manpages='man/%s.1' % t)

=== lib/nss_wrapper/wscript ===
#!/usr/bin/env python

import os

VERSION="1.1.3"

def configure(conf):
    if conf.CHECK_BUNDLED_SYSTEM('nss_wrapper', minversion=VERSION, set_target=False):
        conf.DEFINE('USING_SYSTEM_NSS_WRAPPER', 1)
        libnss_wrapper_so_path = 'libnss_wrapper.so'
    else:
        conf.CHECK_HEADERS('nss.h')

        # check HAVE_GCC_THREAD_LOCAL_STORAGE
        conf.CHECK_CODE('''
            __thread int tls;

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_GCC_THREAD_LOCAL_STORAGE',
            addmain=False,
            msg='Checking for thread local storage')

        # check HAVE_DESTRUCTOR_ATTRIBUTE
        conf.CHECK_CODE('''
            void test_destructor_attribute(void) __attribute__ ((destructor));

            void test_destructor_attribute(void)
            {
                return;
            }

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_DESTRUCTOR_ATTRIBUTE',
            addmain=False,
            msg='Checking for library destructor support')

        conf.CHECK_FUNCS('gethostbyaddr_r gethostbyname_r')
        # Solaris
        conf.CHECK_FUNCS('__posix_getpwnam_r __posix_getpwuid_r')
        conf.CHECK_FUNCS('__posix_getgrgid_r __posix_getgrnam_r')

        conf.CHECK_FUNCS_IN('nsl',
                            'gethostname',
                            checklibc=True,
                            headers='unistd.h')

        # Prototype checks
        conf.CHECK_C_PROTOTYPE('getpwent_r',
                               'struct passwd *getpwent_r(struct passwd *src, char *buf, int buflen)',
                               define='HAVE_SOLARIS_GETPWENT_R', headers='unistd.h pwd.h')
        conf.CHECK_C_PROTOTYPE('getpwnam_r',
                               'int getpwnam_r(const char *name, struct passwd *pwd, char *buf, int buflen, struct passwd **ppwd)',
                               define='HAVE_SOLARIS_GETPWNAM_R', headers='unistd.h pwd.h')
        conf.CHECK_C_PROTOTYPE('getpwuid_r',
                               'int getpwuid_r(uid_t uid, struct passwd *pwd, char *buf, int buflen, struct passwd **ppwd)',
                               define='HAVE_SOLARIS_GETPWUID_R', headers='unistd.h pwd.h')
        conf.CHECK_C_PROTOTYPE('getgrent_r',
                               'struct group *getgrent_r(struct group *src, char *buf, int buflen)',
                               define='HAVE_SOLARIS_GETGRENT_R', headers='unistd.h grp.h')
        conf.CHECK_C_PROTOTYPE('getgrnam_r',
                               'int getgrnam_r(const char *name, struct group *grp, char *buf, int buflen, struct group **pgrp)',
                               define='HAVE_SOLARIS_GETGRNAM_R', headers='unistd.h grp.h')
        conf.CHECK_C_PROTOTYPE('getgrgid_r',
                               'int getgrgid_r(gid_t gid, struct group *grp, char *buf, int buflen, struct group **pgrp)',
                               define='HAVE_SOLARIS_GETGRGID_R', headers='unistd.h grp.h')
        conf.CHECK_C_PROTOTYPE('sethostent',
                               'int sethostent(int stayopen)',
                               define='HAVE_SOLARIS_SETHOSTENT', headers='unistd.h netdb.h')
        conf.CHECK_C_PROTOTYPE('endhostent',
                               'int endhostent(void)',
                               define='HAVE_SOLARIS_ENDHOSTENT', headers='unistd.h netdb.h')
        conf.CHECK_C_PROTOTYPE('gethostname',
                               'int gethostname(char *name, int len)',
                               define='HAVE_SOLARIS_GETHOSTNAME', headers='unistd.h netdb.h')
        conf.CHECK_C_PROTOTYPE('setgrent',
                               'int setgrent(void)',
                               define='HAVE_BSD_SETGRENT', headers='unistd.h grp.h')
        conf.CHECK_C_PROTOTYPE('getnameinfo',
                               'int getnameinfo (const struct sockaddr *sa, socklen_t salen, char *host, socklen_t __hostlen, char *serv, socklen_t servlen, int flags)',
                               define='HAVE_LINUX_GETNAMEINFO', headers='unistd.h netdb.h')
        conf.CHECK_C_PROTOTYPE('getnameinfo',
                               'int getnameinfo (const struct sockaddr *sa, socklen_t salen, char *host, socklen_t __hostlen, char *serv, socklen_t servlen, unsigned int flags)',
                               define='HAVE_LINUX_GETNAMEINFO_UNSIGNED', headers='unistd.h netdb.h')

        # Create full path to nss_wrapper
        srcdir = os.path.realpath(conf.srcdir)
        libnss_wrapper_so_path = srcdir + '/bin/default/lib/nss_wrapper/libnss-wrapper.so'

    conf.DEFINE('LIBNSS_WRAPPER_SO_PATH', libnss_wrapper_so_path)
    conf.DEFINE('NSS_WRAPPER', 1)

def build(bld):
    if bld.CONFIG_SET("HAVE_NSS_H") and not bld.CONFIG_SET("USING_SYSTEM_NSS_WRAPPER"):
        # We need to do it this way or the library wont work.
        # Using private_library=True will add symbol version which
        # breaks preloading!
        bld.SAMBA_LIBRARY('nss_wrapper',
                          source='nss_wrapper.c',
                          deps='dl',
                          install=False,
                          realname='libnss-wrapper.so')

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, Utils

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_CODE('', headers='rpc/rpc.h rpcsvc/yp_prot.h', define='HAVE_RPCSVC_YP_PROT_H')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h')
    conf.CHECK_HEADERS('libgen.h')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    if conf.CONFIG_SET('HAVE_SYS_UCONTEXT_H') and conf.CONFIG_SET('HAVE_SIGNAL_H'):
        conf.CHECK_CODE('''
                       ucontext_t uc;
                       sigaddset(&uc.uc_sigmask, SIGUSR1);
                       ''',
                       'HAVE_UCONTEXT_T',
                       msg="Checking whether we have ucontext_t",
                       headers='signal.h sys/ucontext.h')

    # Check for atomic builtins. */
    conf.CHECK_CODE('''
                    int i;
                    (void)__sync_fetch_and_add(&i, 1);
                    ''',
                    'HAVE___SYNC_FETCH_AND_ADD',
                    msg='Checking for __sync_fetch_and_add compiler builtin')

    conf.CHECK_CODE('''
                    int32_t i;
                    atomic_add_32(&i, 1);
                    ''',
                    'HAVE_ATOMIC_ADD_32',
                    headers='stdint.h sys/atomic.h',
                    msg='Checking for atomic_add_32 compiler builtin')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    # See https://bugzilla.samba.org/show_bug.cgi?id=1097
    #
    # Ported in from autoconf where it was added with this commit:
    # commit 804cfb20a067b4b687089dc72a8271b3abf20f31
    # Author: Simo Sorce <idra@samba.org>
    # Date:   Wed Aug 25 14:24:16 2004 +0000
    #     r2070: Let's try to overload srnlen and strndup for AIX where they are natly broken.

    host_os = sys.platform
    if host_os.rfind('aix') > -1:
        conf.DEFINE('BROKEN_STRNLEN', 1)
        conf.DEFINE('BROKEN_STRNDUP', 1)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes setuid seteuid setreuid setresuid setgid setegid')
    conf.CHECK_FUNCS('setregid setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr strsep')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq memalign posix_memalign')

    if conf.CONFIG_SET('HAVE_MEMALIGN'):
        conf.CHECK_DECLS('memalign', headers='malloc.h')

    conf.CHECK_FUNCS('prctl dirname basename')

    # libbsd on some platforms provides strlcpy and strlcat
    if not conf.CHECK_FUNCS('strlcpy strlcat'):
        conf.CHECK_FUNCS_IN('strlcpy strlcat', 'bsd', headers='bsd/string.h',
                checklibc=True)
    if not conf.CHECK_FUNCS('getpeereid'):
        conf.CHECK_FUNCS_IN('getpeereid', 'bsd', headers='sys/types.h bsd/unistd.h')
    if not conf.CHECK_FUNCS_IN('setproctitle', 'setproctitle', headers='setproctitle.h'):
        conf.CHECK_FUNCS_IN('setproctitle', 'bsd', headers='sys/types.h bsd/unistd.h')

    if not conf.CHECK_FUNCS('closefrom'):
        conf.CHECK_FUNCS_IN('closefrom', 'bsd', headers='bsd/unistd.h')

    conf.CHECK_CODE('''
                struct ucred cred;
                socklen_t cred_len;

=== lib/resolv_wrapper/wscript ===
#!/usr/bin/env python

import os

VERSION="1.1.4"

def configure(conf):
    if conf.CHECK_BUNDLED_SYSTEM('resolv_wrapper', minversion=VERSION, set_target=False):
        conf.DEFINE('USING_SYSTEM_RESOLV_WRAPPER', 1)
        libresolv_wrapper_so_path = 'libresolv_wrapper.so'
    else:
        # check HAVE_GCC_THREAD_LOCAL_STORAGE
        conf.CHECK_CODE('''
            __thread int tls;

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_GCC_THREAD_LOCAL_STORAGE',
            addmain=False,
            msg='Checking for thread local storage')

        # check HAVE_DESTRUCTOR_ATTRIBUTE
        conf.CHECK_CODE('''
            void test_destructor_attribute(void) __attribute__ ((destructor));

            void test_destructor_attribute(void)
            {
                return;
            }

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_DESTRUCTOR_ATTRIBUTE',
            addmain=False,
            msg='Checking for library destructor support')

        # check HAVE_FUNCTION_ATTRIBUTE_FORMAT
        conf.CHECK_CODE('''
            void log_fn(const char *format, ...) __attribute__ ((format (printf, 1, 2)));

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_FUNCTION_ATTRIBUTE_FORMAT',
            addmain=False,
            msg='Checking for printf format validation support')

        conf.CHECK_HEADERS('resolv.h')

        conf.CHECK_STRUCTURE_MEMBER('struct _res_state',
                                    '_u._ext.nsaddrs',
                                    headers='resolv.h',
                                    define='HAVE_RESOLV_IPV6_NSADDRS')

        conf.CHECK_FUNCS_IN('res_ninit', 'resolv')
        if conf.CONFIG_SET('HAVE_RES_NINIT'):
            conf.DEFINE('HAVE_RES_NINIT_IN_LIBRESOLV', 1)

        conf.CHECK_FUNCS_IN('res_nclose', 'resolv')
        if conf.CONFIG_SET('HAVE_RES_NCLOSE'):
            conf.DEFINE('HAVE_RES_NCLOSE_IN_LIBRESOLV', 1)

        conf.CHECK_FUNCS_IN('res_init __res_init', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_ninit __res_ninit', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_close __res_close', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_nclose __res_nclose', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_query __res_query', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_nquery __res_nquery', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_search __res_search', 'resolv', checklibc=True)
        conf.CHECK_FUNCS_IN('res_nsearch __res_nsearch', 'resolv', checklibc=True)

        conf.CHECK_DECLS('ns_name_compress', headers='sys/types.h arpa/nameser.h')
        if (conf.CONFIG_SET("HAVE_DECL_NS_NAME_COMPRESS")):
            conf.DEFINE("HAVE_NS_NAME_COMPRESS", 1)

        # Create full path to resolv_wrapper
        srcdir = os.path.realpath(conf.srcdir)
        libresolv_wrapper_so_path = srcdir + '/bin/default/lib/resolv_wrapper/libresolv-wrapper.so'

    conf.DEFINE('LIBRESOLV_WRAPPER_SO_PATH', libresolv_wrapper_so_path)
    conf.DEFINE('RESOLV_WRAPPER', 1)

def build(bld):
    if bld.CONFIG_SET("HAVE_RESOLV_H") and not bld.CONFIG_SET("USING_SYSTEM_RESOLV_WRAPPER"):
        # We need to do it this way or the library wont work.
        # Using private_library=True will add symbol version which
        # breaks preloading!
        bld.SAMBA_LIBRARY('resolv_wrapper',
                          source='resolv_wrapper.c',
                          deps='dl resolv',
                          install=False,
                          realname='libresolv-wrapper.so')

=== lib/tdb/wscript ===
#!/usr/bin/env python

APPNAME = 'tdb'
VERSION = '1.3.10'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = srcdir + '/..'
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tdb:. lib/replace:lib/replace buildtools:buildtools third_party/waf:third_party/waf')

tdb1_unit_tests = [
    'run-3G-file',
    'run-bad-tdb-header',
    'run',
    'run-check',
    'run-corrupt',
    'run-die-during-transaction',
    'run-endian',
    'run-incompatible',
    'run-nested-transactions',
    'run-nested-traverse',
    'run-no-lock-during-traverse',
    'run-oldhash',
    'run-open-during-transaction',
    'run-readonly-check',
    'run-rescue',
    'run-rescue-find_entry',
    'run-rwlock-check',
    'run-summary',
    'run-transaction-expand',
    'run-traverse-in-transaction',
    'run-wronghash-fail',
    'run-zero-append',
    'run-marklock-deadlock',
    'run-allrecord-traverse-deadlock',
    'run-mutex-openflags2',
    'run-mutex-trylock',
    'run-mutex-allrecord-bench',
    'run-mutex-allrecord-trylock',
    'run-mutex-allrecord-block',
    'run-mutex-transaction1',
    'run-mutex-die',
    'run-mutex1',
]

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('tdb', noextension='tdb')
    opt.RECURSE('lib/replace')
    opt.add_option('--disable-tdb-mutex-locking',
                   help=("Disable the use of pthread robust mutexes"),
                   action="store_true", dest='disable_tdb_mutex_locking',
                   default=False)
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytdb module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.env.disable_tdb_mutex_locking = getattr(Options.options,
                                                 'disable_tdb_mutex_locking',
                                                 False)
    if not conf.env.disable_tdb_mutex_locking:
        conf.env.replace_add_global_pthread = True
    conf.RECURSE('lib/replace')

    conf.env.standalone_tdb = conf.IN_LAUNCH_DIR()
    conf.env.building_tdb = True

    if not conf.env.standalone_tdb:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('tdb', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TDB', 1)
            conf.env.building_tdb = False
            if conf.CHECK_BUNDLED_SYSTEM_PYTHON('pytdb', 'tdb', minversion=VERSION):
                conf.define('USING_SYSTEM_PYTDB', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if (conf.CONFIG_SET('HAVE_ROBUST_MUTEXES') and
        conf.env.building_tdb and
        not conf.env.disable_tdb_mutex_locking):
        conf.define('USE_TDB_MUTEX_LOCKING', 1)

    conf.CHECK_XSLTPROC_MANPAGES()

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.SAMBA_CHECK_PYTHON(mandatory=False)
        conf.check_python_version((2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytdb as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/replace')

    COMMON_FILES='''check.c error.c tdb.c traverse.c
                    freelistcheck.c lock.c dump.c freelist.c
                    io.c open.c transaction.c hash.c summary.c rescue.c
                    mutex.c'''

    COMMON_SRC = bld.SUBDIR('common', COMMON_FILES)

    if bld.env.standalone_tdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TDB'):

        tdb_deps = 'replace'

        if bld.CONFIG_SET('USE_TDB_MUTEX_LOCKING'):
            tdb_deps += ' pthread'

        bld.SAMBA_LIBRARY('tdb',
                          COMMON_SRC,
                          deps=tdb_deps,
                          includes='include',
                          abi_directory='ABI',
                          abi_match='tdb_*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers=('' if private_library else 'include/tdb.h'),
                          public_headers_install=not private_library,
                          pc_files='tdb.pc',
                          private_library=private_library)

        bld.SAMBA_BINARY('tdbtorture',
                         'tools/tdbtorture.c',
                         'tdb',
                         install=False)

        bld.SAMBA_BINARY('tdbrestore',
                         'tools/tdbrestore.c',
                         'tdb', manpages='man/tdbrestore.8')

        bld.SAMBA_BINARY('tdbdump',
                         'tools/tdbdump.c',
                         'tdb', manpages='man/tdbdump.8')

        bld.SAMBA_BINARY('tdbbackup',
                         'tools/tdbbackup.c',
                         'tdb',
                         manpages='man/tdbbackup.8')

        bld.SAMBA_BINARY('tdbtool',
                         'tools/tdbtool.c',
                         'tdb', manpages='man/tdbtool.8')

        if bld.env.standalone_tdb:
            # FIXME: This hardcoded list is stupid, stupid, stupid.
            bld.SAMBA_SUBSYSTEM('tdb-test-helpers',
                                'test/external-agent.c test/lock-tracking.c test/logging.c',
                                tdb_deps,
                                includes='include')

            for t in tdb1_unit_tests:
                b = "tdb1-" + t
                s = "test/" + t + ".c"
                bld.SAMBA_BINARY(b, s, 'replace tdb-test-helpers',
                                 includes='include', install=False)

    if not bld.CONFIG_SET('USING_SYSTEM_PYTDB'):
        for env in bld.gen_python_environments(['PKGCONFIGDIR']):
            bld.SAMBA_PYTHON('pytdb',
                             'pytdb.c',
                             deps='tdb',
                             enabled=not bld.env.disable_python,
                             realname='tdb.so',
                             cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        if not bld.env.disable_python:
            for env in bld.gen_python_environments(['PKGCONFIGDIR']):
                bld.SAMBA_SCRIPT('_tdb_text.py',
                                 pattern='_tdb_text.py',
                                 installdir='python')

                bld.INSTALL_FILES('${PYTHONARCHDIR}', '_tdb_text.py')

def testonly(ctx):
    '''run tdb testsuite'''
    import Utils, samba_utils, shutil
    ecode = 0

    test_prefix = "%s/st" % (Utils.g_module.blddir)
    shutil.rmtree(test_prefix, ignore_errors=True)
    os.makedirs(test_prefix)
    os.environ['TEST_DATA_PREFIX'] = test_prefix

    env = samba_utils.LOAD_ENVIRONMENT()
    # FIXME: This is horrible :(
    if env.building_tdb:
        # Create scratch directory for tests.
        testdir = os.path.join(test_prefix, 'tdb-tests')
        samba_utils.mkdir_p(testdir)
        # Symlink back to source dir so it can find tests in test/
        link = os.path.join(testdir, 'test')
        if not os.path.exists(link):
            os.symlink(os.path.abspath(os.path.join(env.cwd, 'test')), link)

        for t in tdb1_unit_tests:
            f = "tdb1-" + t
            cmd = "cd " + testdir + " && " + os.path.abspath(os.path.join(Utils.g_module.blddir, f)) + " > test-output 2>&1"
            print("..." + f)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s failed:" % f)
                samba_utils.RUN_COMMAND("cat " + os.path.join(testdir, 'test-output'))
                ecode = ret
                break

    if ecode == 0:
        cmd = os.path.join(Utils.g_module.blddir, 'tdbtorture')
        ret = samba_utils.RUN_COMMAND(cmd)
        print("testsuite returned %d" % ret)
        if ret != 0:
            ecode = ret

    pyret = samba_utils.RUN_PYTHON_TESTS(['python/tests/simple.py'])
    print("python testsuite returned %d" % pyret)
    sys.exit(ecode or pyret)

# WAF doesn't build the unit tests for this, maybe because they don't link with tdb?
# This forces it
def test(ctx):
    import Scripting
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== lib/uid_wrapper/wscript ===
#!/usr/bin/env python

import Options
import os, sys

VERSION="1.2.1"

def configure(conf):
    if conf.CHECK_BUNDLED_SYSTEM('uid_wrapper', minversion=VERSION, set_target=False):
        conf.DEFINE('USING_SYSTEM_UID_WRAPPER', 1)
        libuid_wrapper_so_path = 'libuid_wrapper.so'
    else:
        # check HAVE_GCC_ATOMIC_BUILTINS
        conf.CHECK_CODE('''
            #include <stdbool.h>
            int main(void) {
                bool x;
                bool *p_x = &x;
                __atomic_load(p_x, &x, __ATOMIC_RELAXED);
                return 0;
            ''',
            'HAVE_GCC_ATOMIC_BUILTINS',
            addmain=False,
            msg='Checking for atomic builtins')

        # check HAVE_GCC_THREAD_LOCAL_STORAGE
        conf.CHECK_CODE('''
            __thread int tls;

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_GCC_THREAD_LOCAL_STORAGE',
            addmain=False,
            msg='Checking for thread local storage')

        if Options.options.address_sanitizer:
            # check HAVE_ADDRESS_SANITIZER_ATTRIBUTE
            conf.CHECK_CODE('''
                void test_address_sanitizer_attribute(void) __attribute__((no_sanitize_address));

                void test_address_sanitizer_attribute(void)
                {
                    return;
                }

                int main(void) {
                    return 0;
                }
                ''',
                'HAVE_ADDRESS_SANITIZER_ATTRIBUTE',
                addmain=False,
                cflags='-Wall -Wextra -Werror',
                msg='Checking for address sanitizer attribute')

        # check HAVE_FUNCTION_ATTRIBUTE_FORMAT
        conf.CHECK_CODE('''
            void log_fn(const char *format, ...) __attribute__ ((format (printf, 1, 2)));

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_FUNCTION_ATTRIBUTE_FORMAT',
            addmain=False,
            msg='Checking for printf format validation support')
	# Prototype checks
	conf.CHECK_C_PROTOTYPE('setgroups',
			'int setgroups(int ngroups, const gid_t *grouplist)',
			define='HAVE_SETGROUPS_INT', headers='unistd.h sys/types.h')
	conf.CHECK_C_PROTOTYPE('syscall',
			'int syscall(int number, ...)',
			define='HAVE_SYSCALL_INT', headers='unistd.h sys/syscall.h')

        if (sys.platform.rfind('linux') > -1):
            conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>

#ifdef HAVE_SYS_PRIV_H
#include <sys/priv.h>
#endif
#ifdef HAVE_SYS_ID_H
#include <sys/id.h>
#endif

#if defined(HAVE_SYSCALL_H)
#include <syscall.h>
#endif

#if defined(HAVE_SYS_SYSCALL_H)
#include <sys/syscall.h>
#endif

syscall(SYS_setresuid32, -1, -1, -1);
syscall(SYS_setresgid32, -1, -1, -1);
syscall(SYS_setreuid32, -1, -1);
syscall(SYS_setregid32, -1, -1);
syscall(SYS_setuid32, -1);
syscall(SYS_setgid32, -1);
syscall(SYS_setgroups32, 0, NULL);
''',
                'HAVE_LINUX_32BIT_SYSCALLS',
                msg="Checking whether Linux has 32-bit credential calls");

        conf.CHECK_FUNCS('getresuid getresgid')

        # Create full path to uid_wrapper
        srcdir = os.path.realpath(conf.srcdir)
        libuid_wrapper_so_path = srcdir + '/bin/default/lib/uid_wrapper/libuid-wrapper.so'

    conf.DEFINE('LIBUID_WRAPPER_SO_PATH', libuid_wrapper_so_path)
    conf.DEFINE('UID_WRAPPER', 1)

def build(bld):
    if not bld.CONFIG_SET("USING_SYSTEM_UID_WRAPPER"):
        # We need to do it this way or the library wont work.
        # Using private_library=True will add symbol version which
        # breaks preloading!
        bld.SAMBA_LIBRARY('uid_wrapper',
                          source='uid_wrapper.c',
                          deps='dl',
                          install=False,
                          realname='libuid-wrapper.so')

=== debian/changelog ===
samba (2:4.5.16+dfsg-1+deb9u2) stretch-security; urgency=high

  * This is a security release in order to address the following defect:
    - CVE-2018-16860 Heimdal KDC: Reject PA-S4U2Self with unkeyed checksum

 -- Mathieu Parent <sathieu@debian.org>  Wed, 08 May 2019 22:23:37 +0200

samba (2:4.5.16+dfsg-1+deb9u1) stretch-security; urgency=high

  * This is a security release in order to address the following defect:
    - CVE-2019-3880 Save registry file outside share as unprivileged user

 -- Mathieu Parent <sathieu@debian.org>  Fri, 05 Apr 2019 18:28:38 +0200

samba (2:4.5.16+dfsg-1) stretch; urgency=medium

  * New upstream release (latest 4.5.x)
    - Drop merged patches
  * Fix CVE-2018-14629 regression when there're more than 20 records on a non
    CNAME record.
  * Fix rmdir on non-empty samba directory (Closes: #915248)
  * Ignore nmbd start errors when there is no non-loopback interface
    (Closes: #893762)
  * Ignore nmbd start errors when there is  no local IPv4 non-loopback interface
    (Closes: #859526)
  * s3:ntlm_auth: fix memory leak in manage_gensec_request() (Closes: #919611)
  * Add debian/gitlab-ci.yml

 -- Mathieu Parent <sathieu@debian.org>  Thu, 31 Jan 2019 23:12:28 +0100

samba (2:4.5.12+dfsg-2+deb9u4) stretch-security; urgency=high

  * New upstream security release
    - CVE-2018-14629 Unprivileged adding of CNAME record causing loop in AD
      Internal DNS server
    - CVE-2018-16841 Double-free in Samba AD DC KDC with PKINIT
    - CVE-2018-16851 NULL pointer de-reference in Samba AD DC LDAP server

 -- Mathieu Parent <sathieu@debian.org>  Thu, 22 Nov 2018 07:04:59 +0100

samba (2:4.5.12+dfsg-2+deb9u3) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Confidential attribute disclosure from the AD LDAP server (CVE-2018-10919)
  * Insufficient input validation on client directory listing in libsmbclient
    (CVE-2018-10858)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 13 Aug 2018 22:49:33 +0200

samba (2:4.5.12+dfsg-2+deb9u2) stretch-security; urgency=high

  * This is a security release in order to address the following defects:
    - CVE-2018-1050: Codenomicon crashes in spoolss server code
    - CVE-2018-1057: Unprivileged user can change any user (and admin) password

 -- Mathieu Parent <sathieu@debian.org>  Mon, 05 Mar 2018 15:25:39 +0100

samba (2:4.5.12+dfsg-2+deb9u1) stretch-security; urgency=high

  * This is a security release in order to address the following defects:
    - CVE-2017-15275: s3: smbd: Chain code can return uninitialized memory when
      talloc buffer is grown.
    - CVE-2017-14746: s3: smbd: Fix SMB1 use-after-free crash bug.

 -- Mathieu Parent <sathieu@debian.org>  Mon, 20 Nov 2017 23:24:53 +0100

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Ivo De Decker <ivodd@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Andrew Bartlett <abartlet+debian@catalyst.net.nz>
Homepage: http://www.samba.org
Standards-Version: 3.9.8
Build-Depends: bison,
               debhelper (>> 9),
               dh-python,
               dh-systemd (>= 1.5),
               docbook-xml,
               docbook-xsl,
               faketime,
               flex,
               libacl1-dev,
               libaio-dev [linux-any],
               libarchive-dev,
               libattr1-dev,
               libblkid-dev,
               libbsd-dev,
               libcap-dev [linux-any],
               libcups2-dev,
               libgnutls28-dev,
               libgpgme11-dev,
               libldap2-dev,
               libldb-dev (>= 2:1.1.27~),
               libncurses5-dev,
               libpam0g-dev,
               libparse-yapp-perl,
               libpcap-dev [hurd-i386 kfreebsd-any],
               libpopt-dev,
               libreadline-dev,
               libsystemd-dev [linux-any],
               libtalloc-dev (>= 2.1.8~),
               libtdb-dev (>= 1.3.10~),
               libtevent-dev (>= 0.9.29~),
               perl,
               pkg-config,
               po-debconf,
               python-all-dev (>= 2.6.6-3),
               python-dnspython,
               python-ldb (>= 2:1.1.26~),
               python-ldb-dev (>= 2:1.1.26~),
               python-talloc-dev (>= 2.1.8~),
               python-tdb (>= 1.3.8~),
               python-testtools,
               python3,
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-samba/samba.git
Vcs-Git: https://anonscm.debian.org/git/pkg-samba/samba.git

Package: samba
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: adduser,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         lsb-base (>= 4.1+Debian),
         procps,
         python,
         python-dnspython,
         python-samba,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         update-inetd,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: attr, logrotate, samba-dsdb-modules, samba-vfs-modules
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ctdb,
          ldb-tools,
          ntp | chrony (>= 3.0-1),
          smbldap-tools,
          winbind,
          ufw
Enhances: bind9, ntp
Breaks: qtsmbstatus-server (<< 2.2.1-3~)
Replaces: libsamdb0 (<< 4.0.0~alpha17~),
          python-samba (<< 2:4.1.4+dfsg-3),
          samba-ad-dc,
          samba-common (<= 2.0.5a-2),
          samba-doc (<< 2:4.0.5~),
          samba-libs (<< 2:4.1.4+dfsg-2),
          samba4
Conflicts: libldb1 (<< 1:1.1.15),
           samba (<< 2:3.3.0~rc2-5),
           samba-ad-dc,
           samba-doc (<< 2:4.0.5~),
           samba-tools,
           samba4 (<< 4.0.0~alpha6-2)
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an NT4-style domain controller, and can integrate with both NT4 domains
 and Active Directory realms as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 or Active Directory domain controller.
 For use in an NT4 domain or Active Directory realm, you will also need the
 winbind package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libdcerpc-server0 (<< 2:4.0.9),
        libdcerpc0 (<< 2:4.0.9),
        libgensec0 (<< 2:4.0.9),
        libndr-standard0 (<< 2:4.0.9),
        libndr0 (<< 2:4.0.9),
        libnetapi0 (<< 2:4.0.9),
        libregistry0 (<< 2:4.0.9),
        libsamba-credentials0 (<< 2:4.0.9),
        libsamba-hostconfig0 (<< 2:4.0.9),
        libsamba-policy0 (<< 2:4.0.9),
        libsamba-util0 (<< 2:4.0.9),
        libsamdb0 (<< 2:4.0.9),
        libsmbclient-raw0 (<< 2:4.0.9),
        libsmbd0 (<< 2:4.0.9),
        libtorture0 (<< 2:4.0.9)
Replaces: libdcerpc-server0 (<< 2:4.0.9),
          libdcerpc0 (<< 2:4.0.9),
          libgensec0 (<< 2:4.0.9),
          libndr-standard0 (<< 2:4.0.9),
          libndr0 (<< 2:4.0.9),
          libnetapi0 (<< 2:4.0.9),
          libregistry0 (<< 2:4.0.9),
          libsamba-credentials0 (<< 2:4.0.9),
          libsamba-hostconfig0 (<< 2:4.0.9),
          libsamba-policy0 (<< 2:4.0.9),
          libsamba-util0 (<< 2:4.0.9),
          libsamdb0 (<< 2:4.0.9),
          libsmbclient-raw0 (<< 2:4.0.9),
          libsmbd0 (<< 2:4.0.9),
          libtorture0 (<< 2:4.0.9),
          samba (<< 2:4.3.3+dfsg-1)
# these conflicts can NOT be replaced by 'Breaks'
# the old 3.6 packages should be removed before the new samba-libs is
# unpacked, to avoid any code referencing the old location of the tdb files
# see bug #726472
Conflicts: libpam-smbpass (<< 2:4),
           samba (<< 2:4),
           samba-common-bin (<< 2:4),
           samba-dsdb-modules (<< 2:4.1.9+dfsg-2),
           winbind (<< 2:4)
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Replaces: samba (<< 3.0.20b-1),
          samba-doc (<< 2:4.0.5~),
          samba4-common (<< 4.0.0~alpha7-1)
Conflicts: samba-doc (<< 2:4.0.5~), samba4-common (<< 4.0.0~alpha7-1), swat
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python,
         python-samba,
         samba-common (=${source:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}, samba-libs (= ${binary:Version})
Conflicts: samba (<< 2:3.3.0~rc2-5),
           samba-common (<< 2:3.3.0~rc2-5),
           samba-doc (<< 2:4.0.5~)
Replaces: python-samba (<< 2:4.0.6~),
          samba-common (<< 2:3.4.0~pre2-1),
          samba-doc (<< 2:4.0.5~),
          samba4-common (<< 4.0.0~alpha7-1),
          samba4-common-bin
Suggests: heimdal-clients
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}, samba-libs (= ${binary:Version})
Pre-Depends: dpkg (>= 1.15.6~)
Replaces: samba (<< 2.999+3.0.alpha21-4),
          samba-doc (<< 2:4.0.5~),
          samba4-clients (<< 4.0.5),
          smbget
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Conflicts: samba-doc (<< 2:4.0.5~), samba4-clients (<< 4.0.5)
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Replaces: samba-doc (<< 2:4.0.5~),
          samba-libs (<< 2:4.0.10+dfsg-4),
          samba-tools,
          samba4-testsuite
Conflicts: samba-doc (<< 2:4.0.5~), samba-libs (<< 2:4.0.10+dfsg-4)
Depends: samba-common-bin, ${misc:Depends}, ${shlibs:Depends}, samba-libs (= ${binary:Version})
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, samba-libs (= ${binary:Version})
Replaces: samba-doc (<< 2:4.0.5~)
Conflicts: samba-doc (<< 2:4.0.5~)
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: libparse-yapp-perl, ${misc:Depends}, ${perl:Depends}
Recommends: samba-dev
Suggests: libwireshark-dev
Section: perl
Description: IDL compiler written in Perl
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba-dev
Architecture: any
Depends: libc6-dev,
         libldb-dev,
         libparse-pidl-perl,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev (>= 1.2.11),
         libtevent-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Replaces: libdcerpc-dev (<< 2:4.0.9),
          libdcerpc-server-dev (<< 2:4.0.9),
          libgensec-dev (<< 2:4.0.9),
          libndr-dev (<< 2:4.0.9),
          libndr-standard-dev (<< 2:4.0.9),
          libnetapi-dev (<< 2:4.0.9),
          libregistry-dev (<< 2:4.0.9),
          libsamba-credentials-dev (<< 2:4.0.9),
          libsamba-hostconfig-dev (<< 2:4.0.9),
          libsamba-policy-dev (<< 2:4.0.9),
          libsamba-util-dev (<< 2:4.0.9),
          libsamdb (<< 2:4.0.9),
          libsmbclient-raw-dev (<< 2:4.0.9),
          libsmbd-dev (<< 2:4.0.9),
          libtorture-dev (<< 2:4.0.9),
          samba4-dev
Breaks: libdcerpc-dev (<< 2:4.0.9),
        libdcerpc-server-dev (<< 2:4.0.9),
        libgensec-dev (<< 2:4.0.9),

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

PYVERS=$(shell pyversions -vr)

LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_EPOCH = $(shell dpkg-query -f '$${Version}' -W libldb-dev | sed 's/:.*//')
LDB_NEXT_VERSION = $(shell python -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print '.'.join(x)")
# samba ships ldb modules, which are specific to the ldb version, so we need a
# strict dependency on the upstream ldb version
# this also mean samba needs a rebuild when the upstream ldb version changes
LDB_DEPENDS = "libldb1 (<< $(LDB_EPOCH):$(LDB_NEXT_VERSION)~), libldb1 (>> $(LDB_EPOCH):$(LDB_VERSION)~)"
export PYSHORT=$(shell pyversions -d)
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"
WAF = $(PYTHON) ./buildtools/bin/waf -v

# turn DEB_BUILD_OPTIONS='foo,bar' into DEB_BUILD_OPT_FOO and DEB_BUILD_OPT_BAR
d_b_o:=$(shell echo "$$DEB_BUILD_OPTIONS"|sed 's/[^-[:alnum:]]/ /g'|tr a-z A-Z)
$(foreach o, $(d_b_o), $(eval DEB_BUILD_OPT_$o := 1))

# for xsltproc wrapper
export PATH:=$(CURDIR)/debian/bin:$(PATH)
export SOURCE_DATE=$(shell debian/get_source_changedate.pl)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

conf_args = \
		--prefix=/usr \
		--enable-fhs \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--libexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-privatedir=/var/lib/samba/private \
		--with-smbpasswd-file=/etc/samba/smbpasswd \
		--with-piddir=/var/run/samba \
		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
		--with-pam \
		--with-syslog \
		--with-utmp \
		--with-winbind \
		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4 \
		--with-automount \
		--with-ldap \
		--with-ads \
		--with-dnsupdate \
		--with-gpgme \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
		--datadir=/usr/share \
		--with-lockdir=/var/run/samba \
		--with-statedir=/var/lib/samba \
		--with-cachedir=/var/cache/samba \
		--disable-avahi \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser,roken,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
		--builtin-libraries=replace,ccan,samba-cluster-support \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--with-cluster-support \
		--with-socketpath=/var/run/ctdb/ctdbd.socket \
		--with-logdir=/var/log/ctdb

ifeq ($(DEB_HOST_ARCH_OS), linux)
	conf_args += \
		--with-systemd
else
	conf_args += \
		--without-systemd
endif

%:
	dh $* --with python2 --with systemd

override_dh_auto_configure:
	$(WAF) configure $(conf_args)

override_dh_auto_clean:
	-$(WAF) clean
	find . -name "*.pyc" | xargs rm -f
	rm -rf buildtools/bin/.waf-*
	rm -rf bin
	rm -f .lock-wscript
	rm -f ctdb/README.eventscripts
	rm -f ctdb/README.notify.d

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_systemd_start:
	dh_systemd_start -pctdb --no-start --no-restart-on-upgrade

override_dh_installdocs-arch:
	cp ctdb/config/events.d/README ctdb/README.eventscripts
	cp ctdb/config/notify.d.README ctdb/README.notify.d
	dh_installdocs
ifeq ($(DEB_HOST_ARCH_OS), hurd)
	dh_installdocs -pctdb debian/ctdb.README.hurd
endif
ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	dh_installdocs -pctdb debian/ctdb.README.kfreebsd
endif

override_dh_install:
	# get list of files in build log
	find ${DESTDIR}
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.so
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already documented in debian/copyright
	-rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	# pam stuff
	mkdir -p $(DESTDIR)/usr/share/pam-configs
	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	# we don't ship the symlinks
	rm $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_*.so
	#Remove unused ldb share configuration plugin
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba/share/ldb.so
	#Remove unused vfstest manpage vfstest is no longer installed
	rm $(DESTDIR)/usr/share/man/man1/vfstest.1
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/winbind_krb5_locator.so \
	   $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Install samba-common's conffiles - they'll get moved later to their
	# correct place by dh_install
	cp debian/smb.conf* $(DESTDIR)/usr/share/samba/
	install -m755 debian/panic-action $(DESTDIR)/usr/share/samba/panic-action
	cp debian/gdbcommands $(DESTDIR)/etc/samba/
	mkdir -p $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d
	install -m755 debian/samba-common.dhcp $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d/samba
	# Install other stuff not installed by "make install"
	install -m 0755 debian/mksmbpasswd.awk $(DESTDIR)/usr/sbin/mksmbpasswd
	mkdir -p debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba
	mv $(DESTDIR)/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab.so \
	   debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab.so
	mkdir -p $(DESTDIR)/etc/ufw/applications.d
	install -m644 debian/samba.ufw.profile $(DESTDIR)/etc/ufw/applications.d/samba
	# use upstream version of smb.conf.5 if there is no built version
	# this is a temporary workaround for #750593 in xsltproc
	[ -e $(DESTDIR)/usr/share/man/man5/smb.conf.5 ] || \
	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
	# Tests that shouldn't be installed
	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
	# Remove ctdb tests
	rm $(DESTDIR)/usr/bin/ctdb_run_tests
	rm $(DESTDIR)/usr/bin/ctdb_run_cluster_tests
	rm -r $(DESTDIR)/usr/lib/*/ctdb/tests
	rm -r $(DESTDIR)/usr/share/ctdb/tests
	# Install systemd configs
	mkdir -p $(DESTDIR)/lib/systemd/system/
	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
	install -m 0644 packaging/systemd/*.service $(DESTDIR)/lib/systemd/system/
	mv $(DESTDIR)/lib/systemd/system/nmb.service $(DESTDIR)/lib/systemd/system/nmbd.service
	mv $(DESTDIR)/lib/systemd/system/smb.service $(DESTDIR)/lib/systemd/system/smbd.service
	mv $(DESTDIR)/lib/systemd/system/samba.service $(DESTDIR)/lib/systemd/system/samba-ad-dc.service
	sed -i \
	  -e 's|/etc/sysconfig/|/etc/default/|' \
	  -e 's|nmb\.service|nmbd.service|' \
	  -e 's|smb\.service|smbd.service|' \
	  -e 's|samba\.service|samba-ad-dc.service|' \
	  -e 's|^PIDFile=/run/|PIDFile=/var/run/samba/|' \
	  $(DESTDIR)/lib/systemd/system/nmbd.service \
	  $(DESTDIR)/lib/systemd/system/samba-ad-dc.service \
	  $(DESTDIR)/lib/systemd/system/smbd.service \
	  $(DESTDIR)/lib/systemd/system/winbind.service
	mkdir -p $(DESTDIR)/usr/lib/tmpfiles.d
	echo "d /run/samba 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/samba.conf
	#install -m 0644 packaging/systemd/samba.sysconfig $(DESTDIR)/etc/default/samba
	#
	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing

override_dh_python2:

=== debian/watch ===
version=3
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d*$//,pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress" \
	  https://download.samba.org/pub/samba samba-(4\.5\..*).tar.gz
